// Common/StdOutStream.h

#pragma once 

#ifndef __COMMON_STDOUTSTREAM_H
#define __COMMON_STDOUTSTREAM_H

#define	GetCommandLineW g_StdOut.MyGetCommandLineW

#include "../7-zip32.h"
#include "../Dialog.h"
#include "../SplitCmdLine.h"

class CStdOutStream
{
public:
	LPCWSTR GetTempSFXName();
	LPWSTR MyGetCommandLineW();
	void SetCommandLine(const CSplitCmdLine& scl);
	void CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize);
	void ReSet();
	HANDLE m_hThread;
	CProgressDialog* GetProgressDialog() { return m_pDlgProgress; }
	void CloseProgressDialog() { ::PostMessage(m_pDlgProgress->m_hWnd, WM_CLOSE, 0, 1); }
	void SetProgressDialog(CProgressDialog* pDlg) { m_pDlgProgress = pDlg; }
	BOOL SetUnicodeMode(BOOL bUnicode)
	{ 
		if (m_hThread)
			return FALSE;
		m_bUnicode = bUnicode;
		return TRUE;
	}
	BOOL GetUnicodeMode() { return m_bUnicode; }
	CStdOutStream ();
	~CStdOutStream ();
	
	CStdOutStream & operator<<(CStdOutStream & (* aFunction)(CStdOutStream  &));
	CStdOutStream & operator<<(const char *string);
	CStdOutStream & operator<<(const wchar_t *string);
	CStdOutStream & operator<<(char c);
	CStdOutStream & operator<<(int number);
	CStdOutStream & operator<<(UInt64 number);

protected:
	LPWSTR m_lpCommandLine;
	WCHAR m_lpTempSFXName[MAX_PATH];
	CProgressDialog* m_pDlgProgress;
	BOOL m_bUnicode;
	UString m_strLog;
};

CStdOutStream & endl(CStdOutStream & anOut);

extern CStdOutStream g_StdOut;
extern CStdOutStream g_StdErr;

#endif
