// ExtractDialog.cpp: CExtractDialog NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ExtractDialog.h"
#include "shlobj.h"
#include "Common/StringConvert.h"
#include "Windows/ResourceString.h"

using namespace NWindows;

int CALLBACK SHBrowseProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
    if (uMsg == BFFM_INITIALIZED && lpData)
    {
		SendMessage(hWnd, BFFM_SETSELECTION, TRUE, (LPARAM)(LPCSTR)GetOemString((LPCWSTR)lpData));
	}
    return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CExtractDialog::CExtractDialog()
{

}

CExtractDialog::~CExtractDialog()
{

}

bool CExtractDialog::OnInit() 
{
	SetText(m_friendlyName);
	SetItemText(IDC_STATIC_EXTRACT_EXTRACT_TO, m_installPrompt);
	SetItemText(IDC_EXTRACT_COMBO_PATH, m_folderName);
	return CModalDialog::OnInit();
}

void CExtractDialog::OnOK()
{
	TCHAR lpFolderName[MAX_PATH];
	::GetDlgItemText(_window, IDC_EXTRACT_COMBO_PATH, lpFolderName, MAX_PATH);
	m_folderName = GetUnicodeString(lpFolderName);

	CModalDialog::OnOK();
}

bool CExtractDialog::OnButtonClicked(int buttonID, HWND buttonHWND) 
{ 
	switch(buttonID)
	{
    case IDC_EXTRACT_BUTTON_SET_PATH:
		{
			CSysString strTitle = NWindows::MyLoadString(IDS_SELECT_FOLDER_TITLE);
			LPITEMIDLIST pIDList;
			TCHAR szDisplayName[MAX_PATH];
			BROWSEINFO bInfo = { 0 };
			bInfo.hwndOwner		 = _window;
			bInfo.lpszTitle		 = strTitle;
			bInfo.ulFlags		 = BIF_RETURNONLYFSDIRS;
			bInfo.lpfn			 = SHBrowseProc;
			bInfo.lParam		 = (LPARAM)(LPCWSTR)m_folderName;
			
			pIDList = ::SHBrowseForFolder(&bInfo);
			if(pIDList != NULL)
			{
				BOOL bRes;
				bRes = ::SHGetPathFromIDList(pIDList, szDisplayName);
				if(bRes)
				{
					SetItemText(IDC_EXTRACT_COMBO_PATH, szDisplayName);
					m_folderName = GetUnicodeString(szDisplayName);
					::CoTaskMemFree(pIDList);
				}
			}
			break;
		}
	}
	return CModalDialog::OnButtonClicked(buttonID, buttonHWND);
}